package com.example.dashboard;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
public class DashboardController {

    @Autowired ProductRepository productRepository;
    @Autowired OrderRepository orderRepository;

    @RequestMapping(value = "/dashboards/{productId}",
            method = RequestMethod.GET,
            produces = "application/json;charset=UTF-8")
    @ResponseBody
    public List<Object> getDashboard(@PathVariable long productId) throws Exception {

        ObjectMapper mapper = new ObjectMapper();

        Product product  = productRepository.findByProductId(productId);
        List<Order> orders = orderRepository.findListByProductId(productId);

        if (product == null && orders.isEmpty()) {
            return null;
        }

        List<Object> list = new ArrayList<>();

        if (product != null) list.add(product);
        if (!orders.isEmpty()) list.add(orders);

        return list;
    }

    @RequestMapping(value = {"/products","/products/{productId}"},
            method = RequestMethod.GET,
            produces = "application/json;charset=UTF-8")
    public ResponseEntity<Object> getProduct(@PathVariable long productId) throws Exception {
        return ResponseEntity.status(HttpStatus.FORBIDDEN).body("/products method are NOT supported");
    }

    @RequestMapping(value = {"/orders","/orders/{orderId}"},
            method = RequestMethod.GET,
            produces = "application/json;charset=UTF-8")
    public ResponseEntity<Object> getOrder(@PathVariable long orderId) throws Exception {
        return ResponseEntity.status(HttpStatus.FORBIDDEN).body("/orders method are NOT supported");
    }

}
