package com.example.order;

import org.springframework.beans.BeanUtils;

import javax.persistence.*;

@Entity
@Table(name="Orders")
public class Order {
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    private Long id;
    private Long productId;
    private Long userId;
    private int qty;
    private int price;

    public Long getId() {
        return id;
    }
    public void setId(Long id) {
        this.id = id;
    }

    public Long getProductId() {
        return productId;
    }
    public void setProductId(Long productId) {
        this.productId = productId;
    }

    public Long getUserId() {return userId;}
    public void setUserId(Long userId) {this.userId = userId;}

    public int getQty() { return qty; }
    public void setQty(int qty) {
        this.qty = qty;
    }

    public int getPrice() {return price;}
    public void setPrice(int price) {this.price = price;}

    @PrePersist
    public void onPrePersist() {


        /*
        OrderApplication.applicationContext.getBean(ProductService.class)
                .decreaseStock(productId, qty);

        System.out.println("Call for product.decreaseStock has succeeded !! ");

        try {
            System.out.println("processing my own job... ");
            // error function
            raiseDummyException();

        } catch(Exception e) {
            System.out.println("Exception occurred ==> " + e.getMessage());

            // 에러 발생시, 상품 재고를 다시 원복시켜 주어야 함
            publishOrderCancelled();
            System.out.println("Published <OrderCancelled> Event ");
        }


        int res = OrderApplication.applicationContext.getBean(ProductService.class)
                .decreaseStock(productId, qty);

        if (res == -1) {
            throw new RuntimeException("$$$ 존재하지 않는 상품이 주문되었습니다. :: " + productId);
        } else if (res == -2) {
            throw new RuntimeException("$$$ 주문한 상품의 재고가 부족합니다. 재고 확인 바랍니다.");
        }*/

    }

    @PostPersist
    public void onPersist() {
        OrderPlaced orderPlaced = new OrderPlaced();
        BeanUtils.copyProperties(this, orderPlaced);
        orderPlaced.publishAfterCommit();
    }

    @PostRemove
    public void onRemoved() {
        OrderCancelled orderCancelled = new OrderCancelled();
        BeanUtils.copyProperties(this, orderCancelled);
        orderCancelled.publishAfterCommit();
    }

    private void publishOrderCancelled() {
        OrderCancelled orderCancelled = new OrderCancelled();
        BeanUtils.copyProperties(this, orderCancelled);
        orderCancelled.publishAfterCommit();
    }

    private void raiseDummyException() {
        throw new RuntimeException("Dummy Exception !!");
    }

}