package com.example.product;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.stream.annotation.StreamListener;
import org.springframework.messaging.handler.annotation.Payload;
import org.springframework.stereotype.Service;

import java.util.Optional;

@Service
public class EventHandler {
    @Autowired ProductRepository productRepository;

    @StreamListener(StreamProcessor.INPUT)
    public void onOrderCancelled_restoreStock(@Payload OrderCancelled orderCancelled){

        if(!orderCancelled.isMe()) return;
        System.out.println("##### listener restoreStock : " + orderCancelled.toJson());

        Optional<Product> optProduct = productRepository.findById(orderCancelled.getProductId());
        if (optProduct.isEmpty()) return;

        Product product = optProduct.get();
        product.setStock(product.getStock() + orderCancelled.getQty());
        productRepository.save(product);

    }
}
