package com.example.product;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.Optional;

@RestController
public class ProductController {

    @Autowired ProductRepository productRepository;

    // create bus schedule on given month
    @RequestMapping(value = "/products/{productId}/decreaseStock/{qty}",
            method = RequestMethod.PUT,
            produces = "application/json;charset=UTF-8")
    public void decreaseStock(@PathVariable Long productId,
                              @PathVariable int qty) throws Exception {

        Optional<Product> optionalP = productRepository.findById(productId);
        if (!optionalP.isPresent()) {
            throw new RuntimeException("$$$ 존재하지 않는 상품ID입니다. :: " + productId);
        }

        Product product = optionalP.get();

        int stocks = product.getStock();
        if (stocks < qty) {
            throw new RuntimeException("$$$ 상품(" + product.getName() + ")의 현재 재고가 부족합니다. 현재재고 ::  " + stocks);
        }
        product.setStock(stocks - qty);

        productRepository.save(product);
    }

}
